Subject: Re: [RFT][PATCH 4/7] net: dsa: microchip: Remove dev->txbuf

From: Andrew Lunn <[email-masked]>
Date: Fri, 21 Dec 2018 10:30:16 +0100

On Fri, Dec 21, 2018 at 01:02:23AM +0000, [email-masked] wrote:
> > On 12/20/2018 10:41 AM, Andrew Lunn wrote:
> > > On Wed, Dec 19, 2018 at 05:20:33PM -0800, Florian Fainelli wrote:
> > >> On 12/19/18 5:06 PM, Marek Vasut wrote:
> > >>> Previous patches unconver that ksz_spi_write() is always ever called
> > >>> with len = 1, 2 or 4. We can thus drop the if (len > SPI_TX_BUF_LEN)
> > >>> check and we can also drop the allocation of the txbuf which is part
> > >>> of the driver data. This wastes 256 bytes for no reason and can be
> > >>> replaced with 8-byte stack allocated buffer, which is what this patch
> > >>> does. This is an intermediate step though, which will go away after
> > >>> regmap conversion.
> 
> The switch uses auto address increment and can return the whole register
> space in 1 transfer.  Most switches have only 256 registers, so I just stopped
> at that number for KSZ9477.
> 
> This read operation is mostly done by users to dump the registers for debugging.
> The write operation can be used to setup registers from a file.
> 
> I mentioned before the driver can use the standard Linux register access API for
> users to read the chip.  Maybe you also want to try that for debugging.

Hi Tristram

You might want to implement the register dump per port, and connect it
to ethtool --register-dump. The core DSA code has what is needed, you
just need driver specific code. Vivien also sent patches for ethtool
to pritty print the values for the mv88e6xxx. You can do the same for
your chipsets.

     Andrew